/// This file was autogenerated

library app_entry;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'nx_meta.dart';
import 'static_content_url.dart';
part 'app_entry.g.dart';

abstract class AppEntry implements Built<AppEntry, AppEntryBuilder> {
  static Serializer<AppEntry> get serializer => _$appEntrySerializer;

  /// Identifier of the app.
  /// Original name: qID
  @nullable
  @BuiltValueField(wireName: 'qID')
  String get iD;

  /// Title of the app.
  /// Original name: qTitle
  @nullable
  @BuiltValueField(wireName: 'qTitle')
  String get title;

  /// Path of the app.
  /// Original name: qPath
  @nullable
  @BuiltValueField(wireName: 'qPath')
  String get path;

  /// Last reload time of the app.
  /// Original name: qLastReloadTime
  @nullable
  @BuiltValueField(wireName: 'qLastReloadTime')
  String get lastReloadTime;

  /// Is set to true if the app is read-only.
  /// Original name: qReadOnly
  @nullable
  @BuiltValueField(wireName: 'qReadOnly')
  bool get readOnly;

  /// Meta data.
  /// Original name: qMeta
  @nullable
  @BuiltValueField(wireName: 'qMeta')
  NxMeta get meta;

  /// App thumbnail.
  /// Original name: qThumbnail
  @nullable
  @BuiltValueField(wireName: 'qThumbnail')
  StaticContentUrl get thumbnail;

  /// Original name: qFileSize
  @nullable
  @BuiltValueField(wireName: 'qFileSize')
  int get fileSize;

  factory AppEntry([updates(AppEntryBuilder b)]) = _$AppEntry;

  factory AppEntry.init(
      {String iD,
      String title,
      String path,
      String lastReloadTime,
      bool readOnly,
      NxMeta meta,
      StaticContentUrl thumbnail,
      int fileSize}) = _$AppEntry._;

  AppEntry._();
}
