/// This file was autogenerated

library connection;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'nx_meta.dart';
part 'connection.g.dart';

abstract class Connection implements Built<Connection, ConnectionBuilder> {
  static Serializer<Connection> get serializer => _$connectionSerializer;

  /// Identifier of the connection.
  /// Is generated by the engine and is unique.
  /// Original name: qId
  @nullable
  @BuiltValueField(wireName: 'qId')
  String get id;

  /// Name of the connection.
  /// This parameter is mandatory and must be set when creating or modifying a connection.
  /// Original name: qName
  @nullable
  @BuiltValueField(wireName: 'qName')
  String get name;

  /// One of:
  /// * ODBC CONNECT TO [&lt;provider name&gt;]
  /// * OLEDB CONNECT TO [&lt;provider name&gt;]
  /// * CUSTOM CONNECT TO [&lt;provider name&gt;]
  /// * "&lt;local absolute or relative path, UNC path&gt;"
  /// * "&lt;URL&gt;"
  ///
  /// Connection string.
  /// This parameter is mandatory and must be set when creating or modifying a connection.
  /// Original name: qConnectionString
  @nullable
  @BuiltValueField(wireName: 'qConnectionString')
  String get connectionString;

  /// One of:
  /// * ODBC
  /// * OLEDB
  /// * &lt;Name of the custom connection file&gt;
  /// * folder
  /// * internet
  ///
  /// Type of the connection.
  /// This parameter is mandatory and must be set when creating or modifying a connection.
  /// For ODBC, OLEDB and custom connections, the engine checks that the connection type matches the connection string.
  /// The type is not case sensitive.
  /// Original name: qType
  @nullable
  @BuiltValueField(wireName: 'qType')
  String get type;

  /// Name of the user who creates the connection.
  /// This parameter is optional; it is only used for OLEDB, ODBC and CUSTOM connections.
  /// A call to _GetConnection Method_ does not return the user name.
  /// Original name: qUserName
  @nullable
  @BuiltValueField(wireName: 'qUserName')
  String get userName;

  /// Password of the user who creates the connection.
  /// This parameter is optional; it is only used for OLEDB, ODBC and CUSTOM connections.
  /// A call to _GetConnection Method_ does not return the password.
  /// Original name: qPassword
  @nullable
  @BuiltValueField(wireName: 'qPassword')
  String get password;

  /// Is generated by the engine.
  /// Creation date of the connection or last modification date of the connection.
  /// Original name: qModifiedDate
  @nullable
  @BuiltValueField(wireName: 'qModifiedDate')
  String get modifiedDate;

  /// Information about the connection.
  /// Original name: qMeta
  @nullable
  @BuiltValueField(wireName: 'qMeta')
  NxMeta get meta;

  /// Select which user credentials to use to connect to the source.
  /// * LOG_ON_SERVICE_USER: Disables
  /// * LOG_ON_CURRENT_USER: Enables
  ///
  /// One of:
  /// * LOG_ON_SERVICE_USER
  /// * LOG_ON_CURRENT_USER
  /// Original name: qLogOn
  @nullable
  @BuiltValueField(wireName: 'qLogOn')
  String get logOn;

  factory Connection([updates(ConnectionBuilder b)]) = _$Connection;

  factory Connection.init(
      {String id,
      String name,
      String connectionString,
      String type,
      String userName,
      String password,
      String modifiedDate,
      NxMeta meta,
      String logOn}) = _$Connection._;

  Connection._();
}
