/// This file was autogenerated

library custom_connector;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
part 'custom_connector.g.dart';

abstract class CustomConnector
    implements Built<CustomConnector, CustomConnectorBuilder> {
  static Serializer<CustomConnector> get serializer =>
      _$customConnectorSerializer;

  /// Name of the custom connector file.
  /// Original name: qProvider
  @nullable
  @BuiltValueField(wireName: 'qProvider')
  String get provider;

  /// Name of the parent folder that contains the custom connector file.
  /// Original name: qParent
  @nullable
  @BuiltValueField(wireName: 'qParent')
  String get parent;

  /// Name of the custom connector as displayed in the Qlik interface.
  /// Original name: qDisplayName
  @nullable
  @BuiltValueField(wireName: 'qDisplayName')
  String get displayName;

  /// Mode of the machine (64 or 32 bits).
  ///
  /// One of:
  /// * CONNECT_DEFAULT
  /// * CONNECT_64
  /// * CONNECT_32
  /// Original name: qMachineMode
  @nullable
  @BuiltValueField(wireName: 'qMachineMode')
  String get machineMode;

  /// Original name: qSupportFileStreaming
  @nullable
  @BuiltValueField(wireName: 'qSupportFileStreaming')
  bool get supportFileStreaming;

  factory CustomConnector([updates(CustomConnectorBuilder b)]) =
      _$CustomConnector;

  factory CustomConnector.init(
      {String provider,
      String parent,
      String displayName,
      String machineMode,
      bool supportFileStreaming}) = _$CustomConnector._;

  CustomConnector._();
}
