/// This file was autogenerated

library doc_list_entry;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'nx_meta.dart';
import 'static_content_url.dart';
part 'doc_list_entry.g.dart';

abstract class DocListEntry
    implements Built<DocListEntry, DocListEntryBuilder> {
  static Serializer<DocListEntry> get serializer => _$docListEntrySerializer;

  /// Name of the app.
  /// Original name: qDocName
  @nullable
  @BuiltValueField(wireName: 'qDocName')
  String get docName;

  /// Not used.
  /// Original name: qConnectedUsers
  @nullable
  @BuiltValueField(wireName: 'qConnectedUsers')
  int get connectedUsers;

  /// Last modified time stamp of the app.
  /// This property is used only with Qlik Sense Desktop.
  /// It is set to 0 for Qlik Sense Enterprise.
  /// Original name: qFileTime
  @nullable
  @BuiltValueField(wireName: 'qFileTime')
  num get fileTime;

  /// Size of remote app.
  /// This property is used only with Qlik Sense Desktop.
  /// It is set to 0 for Qlik Sense Enterprise.
  /// Original name: qFileSize
  @nullable
  @BuiltValueField(wireName: 'qFileSize')
  num get fileSize;

  /// Identifier of the app.
  /// * In Qlik Sense Desktop, the identifier is the path and name of the app.
  /// * In Qlik Sense Enterprise, the identifier is the app's GUID.
  /// Original name: qDocId
  @nullable
  @BuiltValueField(wireName: 'qDocId')
  String get docId;

  /// Meta data related to the app.
  /// Original name: qMeta
  @nullable
  @BuiltValueField(wireName: 'qMeta')
  NxMeta get meta;

  /// Last reload time of the app.
  /// Original name: qLastReloadTime
  @nullable
  @BuiltValueField(wireName: 'qLastReloadTime')
  String get lastReloadTime;

  /// If set to true, the app is read-only.
  /// Original name: qReadOnly
  @nullable
  @BuiltValueField(wireName: 'qReadOnly')
  bool get readOnly;

  /// Title of the app.
  /// Original name: qTitle
  @nullable
  @BuiltValueField(wireName: 'qTitle')
  String get title;

  /// Thumbnail of the app.
  /// Original name: qThumbnail
  @nullable
  @BuiltValueField(wireName: 'qThumbnail')
  StaticContentUrl get thumbnail;

  factory DocListEntry([updates(DocListEntryBuilder b)]) = _$DocListEntry;

  factory DocListEntry.init(
      {String docName,
      int connectedUsers,
      num fileTime,
      num fileSize,
      String docId,
      NxMeta meta,
      String lastReloadTime,
      bool readOnly,
      String title,
      StaticContentUrl thumbnail}) = _$DocListEntry._;

  DocListEntry._();
}
