/// This file was autogenerated

library drive_info;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
part 'drive_info.g.dart';

abstract class DriveInfo implements Built<DriveInfo, DriveInfoBuilder> {
  static Serializer<DriveInfo> get serializer => _$driveInfoSerializer;

  /// Value of the drive.
  /// Examples:
  /// C:\\\, E:\\\
  /// Original name: qDrive
  @nullable
  @BuiltValueField(wireName: 'qDrive')
  String get drive;

  /// Type of the drive.
  /// _Fixed_ means physical drive.
  /// Original name: qType
  @nullable
  @BuiltValueField(wireName: 'qType')
  String get type;

  /// Name of the drive.
  /// Original name: qName
  @nullable
  @BuiltValueField(wireName: 'qName')
  String get name;

  /// Information about the drive type.
  ///
  /// One of:
  /// * REMOVABLE
  /// * FIXED
  /// * NETWORK
  /// * CD_ROM
  /// * RAM
  /// * UNKNOWN_TYPE
  /// Original name: qTypeIdentifier
  @nullable
  @BuiltValueField(wireName: 'qTypeIdentifier')
  String get typeIdentifier;

  /// Original name: qUnnamedDrive
  @nullable
  @BuiltValueField(wireName: 'qUnnamedDrive')
  bool get unnamedDrive;

  factory DriveInfo([updates(DriveInfoBuilder b)]) = _$DriveInfo;

  factory DriveInfo.init(
      {String drive,
      String type,
      String name,
      String typeIdentifier,
      bool unnamedDrive}) = _$DriveInfo._;

  DriveInfo._();
}
