/// This file was autogenerated

library error_data;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'progress_message.dart';
part 'error_data.g.dart';

abstract class ErrorData implements Built<ErrorData, ErrorDataBuilder> {
  static Serializer<ErrorData> get serializer => _$errorDataSerializer;

  /// Detailed information about the error message.
  /// Original name: qErrorString
  @nullable
  @BuiltValueField(wireName: 'qErrorString')
  String get errorString;

  /// Line termination characters.
  /// Original name: qLineEnd
  @nullable
  @BuiltValueField(wireName: 'qLineEnd')
  String get lineEnd;

  /// Script statement where the error occurs.
  /// Original name: qLine
  @nullable
  @BuiltValueField(wireName: 'qLine')
  String get line;

  /// Type of the error messages.
  ///
  /// One of:
  /// * EDC_ERROR
  /// * EDC_WARNING
  /// * EDC_CIRCULAR_REFERENCE
  /// Original name: qErrorDataCode
  @nullable
  @BuiltValueField(wireName: 'qErrorDataCode')
  String get errorDataCode;

  /// Original name: qMessage
  @nullable
  @BuiltValueField(wireName: 'qMessage')
  ProgressMessage get message;

  factory ErrorData([updates(ErrorDataBuilder b)]) = _$ErrorData;

  factory ErrorData.init(
      {String errorString,
      String lineEnd,
      String line,
      String errorDataCode,
      ProgressMessage message}) = _$ErrorData._;

  ErrorData._();
}
