/// This file was autogenerated

library field_list_def;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
part 'field_list_def.g.dart';

/// Defines the fields to show.
abstract class FieldListDef
    implements Built<FieldListDef, FieldListDefBuilder> {
  static Serializer<FieldListDef> get serializer => _$fieldListDefSerializer;

  /// Shows the system tables if set to true.
  /// Default is false.
  /// Original name: qShowSystem
  @nullable
  @BuiltValueField(wireName: 'qShowSystem')
  bool get showSystem;

  /// Shows the hidden fields if set to true.
  /// Default is false.
  /// Original name: qShowHidden
  @nullable
  @BuiltValueField(wireName: 'qShowHidden')
  bool get showHidden;

  /// Show the semantic fields if set to true.
  /// Default is false.
  /// Original name: qShowSemantic
  @nullable
  @BuiltValueField(wireName: 'qShowSemantic')
  bool get showSemantic;

  /// Shows the tables and fields present in the data model viewer if set to true.
  /// Default is false.
  /// Original name: qShowSrcTables
  @nullable
  @BuiltValueField(wireName: 'qShowSrcTables')
  bool get showSrcTables;

  /// Shows the fields defined on the fly if set to true.
  /// Default is false.
  /// Original name: qShowDefinitionOnly
  @nullable
  @BuiltValueField(wireName: 'qShowDefinitionOnly')
  bool get showDefinitionOnly;

  /// Shows the fields and derived fields if set to true.
  /// Default is false.
  /// Original name: qShowDerivedFields
  @nullable
  @BuiltValueField(wireName: 'qShowDerivedFields')
  bool get showDerivedFields;

  /// Shows the Direct Discovery measure fields if set to true.
  /// Default is false.
  /// Original name: qShowImplicit
  @nullable
  @BuiltValueField(wireName: 'qShowImplicit')
  bool get showImplicit;

  factory FieldListDef([updates(FieldListDefBuilder b)]) = _$FieldListDef;

  factory FieldListDef.init(
      {bool showSystem,
      bool showHidden,
      bool showSemantic,
      bool showSrcTables,
      bool showDefinitionOnly,
      bool showDerivedFields,
      bool showImplicit}) = _$FieldListDef._;

  FieldListDef._();
}
