/// This file was autogenerated

library interact_def;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
part 'interact_def.g.dart';

abstract class InteractDef implements Built<InteractDef, InteractDefBuilder> {
  static Serializer<InteractDef> get serializer => _$interactDefSerializer;

  /// Interaction type.
  ///
  /// One of:
  /// * IT_MSGBOX
  /// * IT_SCRIPTLINE
  /// * IT_BREAK
  /// * IT_INPUT
  /// * IT_END
  /// * IT_PASSWD
  /// * IT_USERNAME
  /// Original name: qType
  @nullable
  @BuiltValueField(wireName: 'qType')
  String get type;

  /// Title used in the message box dialog.
  /// This property is relevant if _qType_ is *IT_MSGBOX*.
  /// Original name: qTitle
  @nullable
  @BuiltValueField(wireName: 'qTitle')
  String get title;

  /// Message used in the message box dialog.
  /// This property is relevant if _qType_ is *IT_MSGBOX*.
  /// Original name: qMsg
  @nullable
  @BuiltValueField(wireName: 'qMsg')
  String get msg;

  /// Buttons displayed in the message box dialog.
  /// This property is relevant if _qType_ is *IT_MSGBOX*.
  /// One of:
  /// * 0 means that the _qButtons_ property is not relevant.
  /// * 17 means that the message box contains the **OK** and **Cancel** buttons or the **stop** -sign icon.
  /// Original name: qButtons
  @nullable
  @BuiltValueField(wireName: 'qButtons')
  int get buttons;

  /// Next script statement to be executed.
  /// This property is used if the type of interaction is *IT_SCRIPTLINE*.
  /// Original name: qLine
  @nullable
  @BuiltValueField(wireName: 'qLine')
  String get line;

  /// First line number of the previously executed statement.
  /// This property is used if the type of interaction is *IT_SCRIPTLINE*.
  /// Original name: qOldLineNr
  @nullable
  @BuiltValueField(wireName: 'qOldLineNr')
  int get oldLineNr;

  /// First line number of the next statement to be executed.
  /// This property is used if the type of interaction is *IT_SCRIPTLINE*.
  /// Original name: qNewLineNr
  @nullable
  @BuiltValueField(wireName: 'qNewLineNr')
  int get newLineNr;

  /// Path specified by the **Include** script variable.
  /// This property is used if the type of interaction is *IT_SCRIPTLINE*.
  /// Example of an **Include** variable:
  /// _$(Include=lib:\\\MyDataFiles\abc.txt);_
  /// Original name: qPath
  @nullable
  @BuiltValueField(wireName: 'qPath')
  String get path;

  /// This property is set to true if the returned statement is an hidden script statement.
  /// Original name: qHidden
  @nullable
  @BuiltValueField(wireName: 'qHidden')
  bool get hidden;

  /// Not relevant for describing the requested user interaction.
  /// Original name: qResult
  @nullable
  @BuiltValueField(wireName: 'qResult')
  int get result;

  /// Is not used in Qlik Sense.
  /// Original name: qInput
  @nullable
  @BuiltValueField(wireName: 'qInput')
  String get input;

  factory InteractDef([updates(InteractDefBuilder b)]) = _$InteractDef;

  factory InteractDef.init(
      {String type,
      String title,
      String msg,
      int buttons,
      String line,
      int oldLineNr,
      int newLineNr,
      String path,
      bool hidden,
      int result,
      String input}) = _$InteractDef._;

  InteractDef._();
}
