/// This file was autogenerated

library list_object;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'size.dart';
import 'nx_validation_error.dart';
import 'nx_dimension_info.dart';
import 'nx_list_object_expression.dart';
import 'package:built_collection/built_collection.dart';
import 'nx_data_page.dart';
part 'list_object.g.dart';

/// Renders the properties of a list object. Is the layout for _ListObjectDef_.
/// For more information about the definition of a list object, see _Generic object_.
/// <div class=note>ListObject is used by the _GetLayout Method_ to display the properties of a list object. </div>
abstract class ListObject implements Built<ListObject, ListObjectBuilder> {
  static Serializer<ListObject> get serializer => _$listObjectSerializer;

  /// Name of the alternate state.
  /// Default is current selections _$_ .
  /// Original name: qStateName
  @nullable
  @BuiltValueField(wireName: 'qStateName')
  String get stateName;

  /// Defines the size of a list object.
  /// Original name: qSize
  @nullable
  @BuiltValueField(wireName: 'qSize')
  Size get size;

  /// This parameter is optional and is displayed in case of error.
  /// Original name: qError
  @nullable
  @BuiltValueField(wireName: 'qError')
  NxValidationError get error;

  /// Information about the dimension.
  /// Original name: qDimensionInfo
  @nullable
  @BuiltValueField(wireName: 'qDimensionInfo')
  NxDimensionInfo get dimensionInfo;

  /// Lists the expressions in the list object.
  /// Original name: qExpressions
  @nullable
  @BuiltValueField(wireName: 'qExpressions')
  BuiltList<NxListObjectExpression> get expressions;

  /// Set of data.
  /// Is empty if nothing has been defined in **qInitialDataFetch** in _ListObjectDef_.
  /// Original name: qDataPages
  @nullable
  @BuiltValueField(wireName: 'qDataPages')
  BuiltList<NxDataPage> get dataPages;

  factory ListObject([updates(ListObjectBuilder b)]) = _$ListObject;

  factory ListObject.init(
      {String stateName,
      Size size,
      NxValidationError error,
      NxDimensionInfo dimensionInfo,
      BuiltList<NxListObjectExpression> expressions,
      BuiltList<NxDataPage> dataPages}) = _$ListObject._;

  ListObject._();
}
