/// This file was autogenerated

library list_object_def;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'nx_inline_dimension_def.dart';
import 'nx_auto_sort_by_state_def.dart';
import 'nx_page.dart';
import 'package:built_collection/built_collection.dart';
import 'nx_list_object_expression_def.dart';
part 'list_object_def.g.dart';

/// Defines the properties of a list object.
/// For more information about the definition of a list object, see _Generic object_.
abstract class ListObjectDef
    implements Built<ListObjectDef, ListObjectDefBuilder> {
  static Serializer<ListObjectDef> get serializer => _$listObjectDefSerializer;

  /// Name of the alternate state.
  /// Default is current selections _$_ .
  /// Original name: qStateName
  @nullable
  @BuiltValueField(wireName: 'qStateName')
  String get stateName;

  /// Refers to a dimension stored in the library.
  /// Original name: qLibraryId
  @nullable
  @BuiltValueField(wireName: 'qLibraryId')
  String get libraryId;

  /// Refers to a dimension stored in the list object.
  /// Original name: qDef
  @nullable
  @BuiltValueField(wireName: 'qDef')
  NxInlineDimensionDef get def;

  /// Defines the sorting by state.
  /// Original name: qAutoSortByState
  @nullable
  @BuiltValueField(wireName: 'qAutoSortByState')
  NxAutoSortByStateDef get autoSortByState;

  /// Defines the frequency mode. The frequency mode is used to calculate the frequency of a value in a list object.
  /// Default is _NX_FREQUENCY_NONE_ .
  /// This parameter is optional.
  ///
  /// One of:
  /// * N or NX_FREQUENCY_NONE
  /// * V or NX_FREQUENCY_VALUE
  /// * P or NX_FREQUENCY_PERCENT
  /// * R or NX_FREQUENCY_RELATIVE
  /// Original name: qFrequencyMode
  @nullable
  @BuiltValueField(wireName: 'qFrequencyMode')
  String get frequencyMode;

  /// If set to true, alternative values are allowed in _qData_ .
  /// If set to false, no alternative values are displayed in _qData_ . Values are excluded instead.
  /// The default value is false.
  /// Note that on the contrary, the _qStateCounts_ parameter counts the excluded values as alternative values.
  /// This parameter is optional.
  /// Original name: qShowAlternatives
  @nullable
  @BuiltValueField(wireName: 'qShowAlternatives')
  bool get showAlternatives;

  /// Fetches an initial data set.
  /// Original name: qInitialDataFetch
  @nullable
  @BuiltValueField(wireName: 'qInitialDataFetch')
  BuiltList<NxPage> get initialDataFetch;

  /// Lists the expressions in the list object.
  /// This parameter is optional.
  /// Original name: qExpressions
  @nullable
  @BuiltValueField(wireName: 'qExpressions')
  BuiltList<NxListObjectExpressionDef> get expressions;

  factory ListObjectDef([updates(ListObjectDefBuilder b)]) = _$ListObjectDef;

  factory ListObjectDef.init(
      {String stateName,
      String libraryId,
      NxInlineDimensionDef def,
      NxAutoSortByStateDef autoSortByState,
      String frequencyMode,
      bool showAlternatives,
      BuiltList<NxPage> initialDataFetch,
      BuiltList<NxListObjectExpressionDef> expressions}) = _$ListObjectDef._;

  ListObjectDef._();
}
