/// This file was autogenerated

library nx_data_page;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'nx_cell.dart';
import 'package:built_collection/built_collection.dart';
import 'nx_group_tail.dart';
import 'rect.dart';
part 'nx_data_page.g.dart';

abstract class NxDataPage implements Built<NxDataPage, NxDataPageBuilder> {
  static Serializer<NxDataPage> get serializer => _$nxDataPageSerializer;

  /// Array of data.
  /// Original name: qMatrix
  @nullable
  @BuiltValueField(wireName: 'qMatrix')
  BuiltList<BuiltList<NxCell>> get matrix;

  /// Array of tails.
  /// Is used for hypercube objects with multiple dimensions. It might happen that due to the window size some elements in a group cannot be displayed in the same page as the other elements of the group. Elements of a group of dimensions can be part of the previous or the next tail.
  /// If there is no tail, the array is empty _[ ]_ .
  /// Original name: qTails
  @nullable
  @BuiltValueField(wireName: 'qTails')
  BuiltList<NxGroupTail> get tails;

  /// Size and offset of the data in the matrix.
  /// Original name: qArea
  @nullable
  @BuiltValueField(wireName: 'qArea')
  Rect get area;

  /// Is set to true, if the data have been reduced.
  /// The default value is false.
  /// Original name: qIsReduced
  @nullable
  @BuiltValueField(wireName: 'qIsReduced')
  bool get isReduced;

  factory NxDataPage([updates(NxDataPageBuilder b)]) = _$NxDataPage;

  factory NxDataPage.init(
      {BuiltList<BuiltList<NxCell>> matrix,
      BuiltList<NxGroupTail> tails,
      Rect area,
      bool isReduced}) = _$NxDataPage._;

  NxDataPage._();
}
