/// This file was autogenerated

library nx_derived_field;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'package:built_collection/built_collection.dart';
part 'nx_derived_field.g.dart';

abstract class NxDerivedField
    implements Built<NxDerivedField, NxDerivedFieldBuilder> {
  static Serializer<NxDerivedField> get serializer =>
      _$nxDerivedFieldSerializer;

  /// Identifier of the derived field.
  /// The identifier is unique.
  /// Original name: qId
  @nullable
  @BuiltValueField(wireName: 'qId')
  String get id;

  /// Combination of field name, definition and method.
  /// Example:
  /// _OrderDate.MyDefinition.Year_
  /// Original name: qName
  @nullable
  @BuiltValueField(wireName: 'qName')
  String get name;

  /// Method name associated to the derived field.
  /// Original name: qMethod
  @nullable
  @BuiltValueField(wireName: 'qMethod')
  String get method;

  /// Expression of the derived field.
  /// Example:
  /// If _qName_ is _OrderDate.MyDefinition.Year_ , the expression is as follows:
  /// _=${Mydefinition(OrderDate).Year}_
  /// Original name: qExpr
  @nullable
  @BuiltValueField(wireName: 'qExpr')
  String get expr;

  /// List of tags.
  /// Original name: qTags
  @nullable
  @BuiltValueField(wireName: 'qTags')
  BuiltList<String> get tags;

  factory NxDerivedField([updates(NxDerivedFieldBuilder b)]) = _$NxDerivedField;

  factory NxDerivedField.init(
      {String id,
      String name,
      String method,
      String expr,
      BuiltList<String> tags}) = _$NxDerivedField._;

  NxDerivedField._();
}
