/// This file was autogenerated

library nx_page_tree_node;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'rect.dart';
part 'nx_page_tree_node.g.dart';

/// Defines an area of the tree to be fetched.
abstract class NxPageTreeNode
    implements Built<NxPageTreeNode, NxPageTreeNodeBuilder> {
  static Serializer<NxPageTreeNode> get serializer =>
      _$nxPageTreeNodeSerializer;

  /// The area of the tree to be fetched. If no area is defined on a dimension, all existing nodes are included.
  /// Original name: qArea
  @nullable
  @BuiltValueField(wireName: 'qArea')
  Rect get area;

  /// When set to true, generated nodes (based on current selection) will be inserted into the returned tree even when there is no actual value. For example, suppose you are looking for hybrid car sales at all car dealerships. Normally, only dealerships where hybrid cars are sold would be part of the returned tree but with qAllValues set to true, all available dealerships will be included regardless if they sold any hybrid cars or not.
  /// Original name: qAllValues
  @nullable
  @BuiltValueField(wireName: 'qAllValues')
  bool get allValues;

  factory NxPageTreeNode([updates(NxPageTreeNodeBuilder b)]) = _$NxPageTreeNode;

  factory NxPageTreeNode.init({Rect area, bool allValues}) = _$NxPageTreeNode._;

  NxPageTreeNode._();
}
