/// This file was autogenerated

library nx_stacked_pivot_cell;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'nx_stacked_pivot_cell.dart';
import 'package:built_collection/built_collection.dart';
import 'nx_attribute_expression_values.dart';
import 'nx_attribute_dim_values.dart';
part 'nx_stacked_pivot_cell.g.dart';

abstract class NxStackedPivotCell
    implements Built<NxStackedPivotCell, NxStackedPivotCellBuilder> {
  static Serializer<NxStackedPivotCell> get serializer =>
      _$nxStackedPivotCellSerializer;

  /// Some text.
  /// Original name: qText
  @nullable
  @BuiltValueField(wireName: 'qText')
  String get text;

  /// Rank number of the value.
  /// If set to -1, it means that the value is not an element number.
  /// Original name: qElemNo
  @nullable
  @BuiltValueField(wireName: 'qElemNo')
  int get elemNo;

  /// Value of the cell.
  /// Is set to _NaN_ , if the value is not a number.
  /// Original name: qValue
  @nullable
  @BuiltValueField(wireName: 'qValue')
  num get value;

  /// If set to true, it means that the cell can be expanded.
  /// This parameter is not returned if it is set to false.
  /// Original name: qCanExpand
  @nullable
  @BuiltValueField(wireName: 'qCanExpand')
  bool get canExpand;

  /// If set to true, it means that the cell can be collapsed.
  /// This parameter is not returned if it is set to false.
  /// Original name: qCanCollapse
  @nullable
  @BuiltValueField(wireName: 'qCanCollapse')
  bool get canCollapse;

  /// Type of the cell.
  ///
  /// One of:
  /// * V or NX_DIM_CELL_VALUE
  /// * E or NX_DIM_CELL_EMPTY
  /// * N or NX_DIM_CELL_NORMAL
  /// * T or NX_DIM_CELL_TOTAL
  /// * O or NX_DIM_CELL_OTHER
  /// * A or NX_DIM_CELL_AGGR
  /// * P or NX_DIM_CELL_PSEUDO
  /// * R or NX_DIM_CELL_ROOT
  /// * U or NX_DIM_CELL_NULL
  /// * G or NX_DIM_CELL_GENERATED
  /// Original name: qType
  @nullable
  @BuiltValueField(wireName: 'qType')
  String get type;

  /// Total of the positive values in the current group of cells.
  /// Original name: qMaxPos
  @nullable
  @BuiltValueField(wireName: 'qMaxPos')
  num get maxPos;

  /// Total of the negative values in the current group of cells.
  /// Original name: qMinNeg
  @nullable
  @BuiltValueField(wireName: 'qMinNeg')
  num get minNeg;

  /// Number of elements that are part of the previous tail.
  /// Original name: qUp
  @nullable
  @BuiltValueField(wireName: 'qUp')
  int get up;

  /// Number of elements that are part of the next tail.
  /// Original name: qDown
  @nullable
  @BuiltValueField(wireName: 'qDown')
  int get down;

  /// Row index in the data matrix.
  /// The indexing starts from 0.
  /// Original name: qRow
  @nullable
  @BuiltValueField(wireName: 'qRow')
  int get row;

  /// Information about sub nodes (or sub cells).
  /// The array is empty _[ ]_ when there are no sub nodes.
  /// Original name: qSubNodes
  @nullable
  @BuiltValueField(wireName: 'qSubNodes')
  BuiltList<NxStackedPivotCell> get subNodes;

  /// Attribute expressions values.
  /// Original name: qAttrExps
  @nullable
  @BuiltValueField(wireName: 'qAttrExps')
  NxAttributeExpressionValues get attrExps;

  /// Attribute dimensions values.
  /// Original name: qAttrDims
  @nullable
  @BuiltValueField(wireName: 'qAttrDims')
  NxAttributeDimValues get attrDims;

  factory NxStackedPivotCell([updates(NxStackedPivotCellBuilder b)]) =
      _$NxStackedPivotCell;

  factory NxStackedPivotCell.init(
      {String text,
      int elemNo,
      num value,
      bool canExpand,
      bool canCollapse,
      String type,
      num maxPos,
      num minNeg,
      int up,
      int down,
      int row,
      BuiltList<NxStackedPivotCell> subNodes,
      NxAttributeExpressionValues attrExps,
      NxAttributeDimValues attrDims}) = _$NxStackedPivotCell._;

  NxStackedPivotCell._();
}
