/// This file was autogenerated

library search_combination_options;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'package:built_collection/built_collection.dart';
part 'search_combination_options.g.dart';

abstract class SearchCombinationOptions
    implements
        Built<SearchCombinationOptions, SearchCombinationOptionsBuilder> {
  static Serializer<SearchCombinationOptions> get serializer =>
      _$searchCombinationOptionsSerializer;

  /// List of the search fields.
  /// If empty, the search is performed in all fields of the app.
  /// Original name: qSearchFields
  @nullable
  @BuiltValueField(wireName: 'qSearchFields')
  BuiltList<String> get searchFields;

  /// Search context.
  /// The default value is _LockedFieldsOnly_ .
  ///
  /// One of:
  /// * Cleared or CONTEXT_CLEARED
  /// * LockedFieldsOnly or CONTEXT_LOCKED_FIELDS_ONLY
  /// * CurrentSelections or CONTEXT_CURRENT_SELECTIONS
  /// Original name: qContext
  @nullable
  @BuiltValueField(wireName: 'qContext')
  String get context;

  /// Encoding used to compute qRanges of type SearchCharRange.
  /// <div class=note>Only affects the computation of the ranges. It does not impact the encoding of the text.</div>
  ///
  /// One of:
  /// * Utf8 or CHAR_ENCODING_UTF8
  /// * Utf16 or CHAR_ENCODING_UTF16
  /// Original name: qCharEncoding
  @nullable
  @BuiltValueField(wireName: 'qCharEncoding')
  String get charEncoding;

  /// Optional.
  /// * For SearchSuggest method, this array is empty.
  /// * For SearchObjects method, this array is empty or contain _qProperty_ .
  /// * For SearchResults method, this array is empty, or contains _qNum_ and/or _qElemNum_ . It allows the user to request details in the outputted _SearchGroupItemMatch_ . For more information, see _SearchGroupItemMatch_.
  /// Original name: qAttributes
  @nullable
  @BuiltValueField(wireName: 'qAttributes')
  BuiltList<String> get attributes;

  factory SearchCombinationOptions(
          [updates(SearchCombinationOptionsBuilder b)]) =
      _$SearchCombinationOptions;

  factory SearchCombinationOptions.init(
      {BuiltList<String> searchFields,
      String context,
      String charEncoding,
      BuiltList<String> attributes}) = _$SearchCombinationOptions._;

  SearchCombinationOptions._();
}
