/// This file was autogenerated

library search_group;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'package:built_collection/built_collection.dart';
import 'search_group_item.dart';
part 'search_group.g.dart';

abstract class SearchGroup implements Built<SearchGroup, SearchGroupBuilder> {
  static Serializer<SearchGroup> get serializer => _$searchGroupSerializer;

  /// Identifier of the search group.
  /// Original name: qId
  @nullable
  @BuiltValueField(wireName: 'qId')
  int get id;

  /// Type of the search group.
  ///
  /// One of:
  /// * DatasetType or DATASET_GROUP
  /// * GenericObjectsType or GENERIC_OBJECTS_GROUP
  /// Original name: qGroupType
  @nullable
  @BuiltValueField(wireName: 'qGroupType')
  String get groupType;

  /// Indexes of the search terms that are included in the group. These search terms are related to the list of terms defined in _SearchResult.qSearchTerms_ .
  /// Original name: qSearchTermsMatched
  @nullable
  @BuiltValueField(wireName: 'qSearchTermsMatched')
  BuiltList<int> get searchTermsMatched;

  /// Total number of distinct items in the search group.
  /// Original name: qTotalNumberOfItems
  @nullable
  @BuiltValueField(wireName: 'qTotalNumberOfItems')
  int get totalNumberOfItems;

  /// List of items in the search group.
  /// The group items are numbered from the value of _SearchGroupOptions.qOffset_ to the value of _SearchGroupOptions.qOffset_ \+ _SearchGroupOptions.qCount_
  /// Original name: qItems
  @nullable
  @BuiltValueField(wireName: 'qItems')
  BuiltList<SearchGroupItem> get items;

  factory SearchGroup([updates(SearchGroupBuilder b)]) = _$SearchGroup;

  factory SearchGroup.init(
      {int id,
      String groupType,
      BuiltList<int> searchTermsMatched,
      int totalNumberOfItems,
      BuiltList<SearchGroupItem> items}) = _$SearchGroup._;

  SearchGroup._();
}
