/// This file was autogenerated

library search_group_item;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'search_group_item_match.dart';
import 'package:built_collection/built_collection.dart';
part 'search_group_item.g.dart';

abstract class SearchGroupItem
    implements Built<SearchGroupItem, SearchGroupItemBuilder> {
  static Serializer<SearchGroupItem> get serializer =>
      _$searchGroupItemSerializer;

  /// Type of the group item.
  ///
  /// One of:
  /// * Field or FIELD
  /// * GenericObject or GENERIC_OBJECT
  /// Original name: qItemType
  @nullable
  @BuiltValueField(wireName: 'qItemType')
  String get itemType;

  /// Total number of distinct matches in the search group item.
  /// Original name: qTotalNumberOfMatches
  @nullable
  @BuiltValueField(wireName: 'qTotalNumberOfMatches')
  int get totalNumberOfMatches;

  /// Identifier of the item.
  /// It corresponds to:
  /// * The name of the field, if the type of the search group is data set.
  /// * The id of the generic object if the type of the search group is generic object.
  /// Original name: qIdentifier
  @nullable
  @BuiltValueField(wireName: 'qIdentifier')
  String get identifier;

  /// List of matches in the search group item.
  /// The group item matches are numbered from the value of _SearchGroupItemOptions.qOffset_ to the value of _SearchGroupItemOptions.qOffset_ \+ _SearchGroupItemOptions.qCount_ .
  /// Original name: qItemMatches
  @nullable
  @BuiltValueField(wireName: 'qItemMatches')
  BuiltList<SearchGroupItemMatch> get itemMatches;

  /// Indexes of the search terms that are included in the group item. These search terms are related to the list of terms defined in _SearchResult.qSearchTerms_ .
  /// Original name: qSearchTermsMatched
  @nullable
  @BuiltValueField(wireName: 'qSearchTermsMatched')
  BuiltList<int> get searchTermsMatched;

  factory SearchGroupItem([updates(SearchGroupItemBuilder b)]) =
      _$SearchGroupItem;

  factory SearchGroupItem.init(
      {String itemType,
      int totalNumberOfMatches,
      String identifier,
      BuiltList<SearchGroupItemMatch> itemMatches,
      BuiltList<int> searchTermsMatched}) = _$SearchGroupItem._;

  SearchGroupItem._();
}
