/// This file was autogenerated

library search_group_options;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
part 'search_group_options.g.dart';

abstract class SearchGroupOptions
    implements Built<SearchGroupOptions, SearchGroupOptionsBuilder> {
  static Serializer<SearchGroupOptions> get serializer =>
      _$searchGroupOptionsSerializer;

  /// Type of the group. Can be:
  /// * GenericObjectType: the type of the search group item is a generic object. Groups have this type when you are calling _SearchObjects_ .
  /// * DatasetType: type of the search group item is a dataset association. Groups have this type when you are calling _SearchResults_ .
  ///
  /// One of:
  /// * DatasetType or DATASET_GROUP
  /// * GenericObjectsType or GENERIC_OBJECTS_GROUP
  /// Original name: qGroupType
  @nullable
  @BuiltValueField(wireName: 'qGroupType')
  String get groupType;

  /// Position starting from 0.
  /// The default value is 0.
  /// Original name: qOffset
  @nullable
  @BuiltValueField(wireName: 'qOffset')
  int get offset;

  /// Maximum number of items per group (in _qItems[ ]_ ).
  /// The default value is -1; all values are returned.
  /// Original name: qCount
  @nullable
  @BuiltValueField(wireName: 'qCount')
  int get count;

  factory SearchGroupOptions([updates(SearchGroupOptionsBuilder b)]) =
      _$SearchGroupOptions;

  factory SearchGroupOptions.init({String groupType, int offset, int count}) =
      _$SearchGroupOptions._;

  SearchGroupOptions._();
}
