/// This file was autogenerated

library search_page;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'search_group_options.dart';
import 'package:built_collection/built_collection.dart';
import 'search_group_item_options.dart';
part 'search_page.g.dart';

abstract class SearchPage implements Built<SearchPage, SearchPageBuilder> {
  static Serializer<SearchPage> get serializer => _$searchPageSerializer;

  /// Position from the top, starting from 0.
  /// If the offset is set to 0, the first search result to be returned is at position 0.
  /// Original name: qOffset
  @nullable
  @BuiltValueField(wireName: 'qOffset')
  int get offset;

  /// Number of search groups to return (in _qSearchGroupArray_ ).
  /// Original name: qCount
  @nullable
  @BuiltValueField(wireName: 'qCount')
  int get count;

  /// Maximum number of matching values to return per search result.
  /// The default value is -1; all values are returned.
  /// This property is to be used with the _SearchAssociations method_.
  /// Original name: qMaxNbrFieldMatches
  @nullable
  @BuiltValueField(wireName: 'qMaxNbrFieldMatches')
  int get maxNbrFieldMatches;

  /// Options of the search groups.
  /// If this property is not set, all values are returned.
  /// This property is to be used with the _SearchResults method_ or the _SearchObjects method_.
  /// Original name: qGroupOptions
  @nullable
  @BuiltValueField(wireName: 'qGroupOptions')
  BuiltList<SearchGroupOptions> get groupOptions;

  /// Options of the search group items.
  /// If this property is not set, all values are returned.
  /// This property is to be used with the _SearchResults method_ or the _SearchObjects method_.
  /// Original name: qGroupItemOptions
  @nullable
  @BuiltValueField(wireName: 'qGroupItemOptions')
  BuiltList<SearchGroupItemOptions> get groupItemOptions;

  factory SearchPage([updates(SearchPageBuilder b)]) = _$SearchPage;

  factory SearchPage.init(
      {int offset,
      int count,
      int maxNbrFieldMatches,
      BuiltList<SearchGroupOptions> groupOptions,
      BuiltList<SearchGroupItemOptions> groupItemOptions}) = _$SearchPage._;

  SearchPage._();
}
