/// This file was autogenerated

library sort_criteria;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'value_expr.dart';
part 'sort_criteria.g.dart';

abstract class SortCriteria
    implements Built<SortCriteria, SortCriteriaBuilder> {
  static Serializer<SortCriteria> get serializer => _$sortCriteriaSerializer;

  /// Sorts the field values according to their logical state (selected, optional, alternative or excluded).
  /// Original name: qSortByState
  @nullable
  @BuiltValueField(wireName: 'qSortByState')
  int get sortByState;

  /// Sorts the field values by frequency (number of occurrences in the field).
  /// Original name: qSortByFrequency
  @nullable
  @BuiltValueField(wireName: 'qSortByFrequency')
  int get sortByFrequency;

  /// Sorts the field values by numeric value.
  /// Original name: qSortByNumeric
  @nullable
  @BuiltValueField(wireName: 'qSortByNumeric')
  int get sortByNumeric;

  /// Sorts the field by alphabetical order.
  /// Original name: qSortByAscii
  @nullable
  @BuiltValueField(wireName: 'qSortByAscii')
  int get sortByAscii;

  /// Sorts the field values by the initial load order.
  /// Original name: qSortByLoadOrder
  @nullable
  @BuiltValueField(wireName: 'qSortByLoadOrder')
  int get sortByLoadOrder;

  /// Sorts the field by expression.
  /// Original name: qSortByExpression
  @nullable
  @BuiltValueField(wireName: 'qSortByExpression')
  int get sortByExpression;

  /// Sort by expression.
  /// Original name: qExpression
  @nullable
  @BuiltValueField(wireName: 'qExpression')
  ValueExpr get expression;

  /// Original name: qSortByGreyness
  @nullable
  @BuiltValueField(wireName: 'qSortByGreyness')
  int get sortByGreyness;

  factory SortCriteria([updates(SortCriteriaBuilder b)]) = _$SortCriteria;

  factory SortCriteria.init(
      {int sortByState,
      int sortByFrequency,
      int sortByNumeric,
      int sortByAscii,
      int sortByLoadOrder,
      int sortByExpression,
      ValueExpr expression,
      int sortByGreyness}) = _$SortCriteria._;

  SortCriteria._();
}
