/// This file was autogenerated

library string_expression;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
part 'string_expression.g.dart';

/// ### Properties
/// Abbreviated syntax:
/// "qStringExpression":"=&lt;expression&gt;"
/// Extended object syntax:
/// "qStringExpression":{"qExpr":"=&lt;expression&gt;"}
/// Where:
/// * &lt; **expression** &gt; is a string
///
/// <div class=note>The "=" sign in the string expression is not mandatory. Even if the "=" sign is not given, the expression is evaluated.</div> <div class=note>A string expression is not evaluated, if the expression is surrounded by simple quotes.</div>
/// The result of the evaluation of the expression can be of any type, as it is returned as a JSON (quoted) string.
abstract class StringExpression
    implements Built<StringExpression, StringExpressionBuilder> {
  static Serializer<StringExpression> get serializer =>
      _$stringExpressionSerializer;

  /// Original name: qExpr
  @nullable
  @BuiltValueField(wireName: 'qExpr')
  String get expr;

  factory StringExpression([updates(StringExpressionBuilder b)]) =
      _$StringExpression;

  factory StringExpression.init({String expr}) = _$StringExpression._;

  StringExpression._();
}
