/// This file was autogenerated

library table_record;

import 'package:built_value/serializer.dart';
import 'package:built_value/built_value.dart';
import 'field_in_table_data.dart';
import 'package:built_collection/built_collection.dart';
import 'point.dart';
part 'table_record.g.dart';

abstract class TableRecord implements Built<TableRecord, TableRecordBuilder> {
  static Serializer<TableRecord> get serializer => _$tableRecordSerializer;

  /// Name of the table.
  /// Original name: qName
  @nullable
  @BuiltValueField(wireName: 'qName')
  String get name;

  /// This property is set to true if the table is loose.
  /// Original name: qLoose
  @nullable
  @BuiltValueField(wireName: 'qLoose')
  bool get loose;

  /// Number of rows in the table.
  /// Original name: qNoOfRows
  @nullable
  @BuiltValueField(wireName: 'qNoOfRows')
  int get noOfRows;

  /// Information about the fields in the table.
  /// Original name: qFields
  @nullable
  @BuiltValueField(wireName: 'qFields')
  BuiltList<FieldInTableData> get fields;

  /// Information about the position of the table.
  /// Original name: qPos
  @nullable
  @BuiltValueField(wireName: 'qPos')
  Point get pos;

  /// Comment related to the table.
  /// Original name: qComment
  @nullable
  @BuiltValueField(wireName: 'qComment')
  String get comment;

  /// If set to true, Direct Discovery is used.
  /// Direct Discovery fields are not loaded into memory and remain in the external database.
  /// Original name: qIsDirectDiscovery
  @nullable
  @BuiltValueField(wireName: 'qIsDirectDiscovery')
  bool get isDirectDiscovery;

  /// This property is set to true if the table contains a synthetic key.
  /// Original name: qIsSynthetic
  @nullable
  @BuiltValueField(wireName: 'qIsSynthetic')
  bool get isSynthetic;

  factory TableRecord([updates(TableRecordBuilder b)]) = _$TableRecord;

  factory TableRecord.init(
      {String name,
      bool loose,
      int noOfRows,
      BuiltList<FieldInTableData> fields,
      Point pos,
      String comment,
      bool isDirectDiscovery,
      bool isSynthetic}) = _$TableRecord._;

  TableRecord._();
}
