library serializers;

import 'package:built_value/serializer.dart';
import 'package:built_collection/built_collection.dart';
import '../models.dart';

part 'serializers.g.dart';

@SerializersFor(const [
  ExportDataResult,
  GetHyperCubeContinuousDataResult,
  CreateAppResult,
  GetTablesAndKeysResult,
  CheckExpressionResult,
  FieldValue,
  NxFieldProperties,
  AlfaNumString,
  NxVariableProperties,
  FieldAttributes,
  GenericObjectLayout,
  NxInfo,
  NxMeta,
  NxLayoutErrors,
  NxSelectionInfo,
  NxPage,
  NxDataPage,
  NxCell,
  NxHighlightRanges,
  CharRange,
  NxAttributeExpressionValues,
  NxSimpleValue,
  NxAttributeDimValues,
  NxSimpleDimValue,
  NxGroupTail,
  Rect,
  NxPivotPage,
  NxPivotDimensionCell,
  NxPivotValuePoint,
  NxStackPage,
  NxStackedPivotCell,
  NxContinuousDataOptions,
  NxAxisData,
  NxAxisTicks,
  NxTickCell,
  NxTreeDataOption,
  NxPageTreeNode,
  NxPageTreeLevel,
  NxTreeNode,
  NxTreeValue,
  NxViewPort,
  NxDataAreaPage,
  NxPatch,
  GenericObjectProperties,
  GenericObjectEntry,
  GenericBookmarkEntry,
  GenericBookmarkProperties,
  NxBookmark,
  AlternateStateData,
  BookmarkFieldItem,
  FieldDefEx,
  SelectInfo,
  RangeSelectInfo,
  Range,
  BookmarkVariableItem,
  NxSelectionCell,
  NxRangeSelectInfo,
  NxMultiRangeSelectInfo,
  NxTreeMultiRangeSelectInfo,
  NxTreeRangeSelectInfo,
  NxContinuousRangeSelectInfo,
  ObjectInterface,
  NxLinkedObjectInfo,
  AppObjectListDef,
  AppObjectList,
  NxContainerEntry,
  BookmarkListDef,
  BookmarkList,
  ChildListDef,
  ChildList,
  DimensionListDef,
  DimensionList,
  ExtensionList,
  FieldListDef,
  FieldList,
  NxFieldDescription,
  NxDerivedFieldDescriptionList,
  NxDerivedFieldsData,
  NxDerivedField,
  NxDerivedGroup,
  HyperCubeDef,
  NxDimension,
  NxInlineDimensionDef,
  SortCriteria,
  ValueExpr,
  OtherTotalSpecProp,
  StringExpr,
  NxAttrExprDef,
  NxAttrDimDef,
  NxCalcCond,
  NxMeasure,
  NxInlineMeasureDef,
  HyperCube,
  Size,
  NxValidationError,
  NxDimensionInfo,
  NxStateCounts,
  NxAttrExprInfo,
  NxAttrDimInfo,
  NxMeasureInfo,
  NxCellPosition,
  ListObjectDef,
  NxAutoSortByStateDef,
  NxListObjectExpressionDef,
  ListObject,
  NxListObjectExpression,
  MeasureListDef,
  MeasureList,
  MediaList,
  MediaListItem,
  NxLibraryDimensionDef,
  NxLibraryDimension,
  NxLibraryMeasureDef,
  NxLibraryMeasure,
  SelectionObjectDef,
  SelectionObject,
  NxCurrentSelectionItem,
  NxFieldSelectionInfo,
  StaticContentUrlDef,
  StaticContentUrl,
  StringExpression,
  TreeDataDef,
  NxTreeDimensionDef,
  TreeData,
  NxTreeDimensionInfo,
  UndoInfo,
  ValueExpression,
  VariableListDef,
  VariableList,
  NxVariableListItem,
  GenericDimensionLayout,
  GenericDimensionInfo,
  GenericDimensionProperties,
  BookmarkFieldPage,
  GenericBookmarkLayout,
  LayoutFieldInfo,
  GenericVariableLayout,
  GenericVariableProperties,
  GenericMeasureLayout,
  GenericMeasureProperties,
  FieldDescription,
  LocaleInfo,
  CalendarStrings,
  TableRecord,
  FieldInTableData,
  DerivedFieldsInTableData,
  Point,
  SourceKeyRecord,
  TableViewDlgSaveInfo,
  TableViewCtlSaveInfo,
  TableViewSaveInfo,
  TableViewTableWinSaveInfo,
  TableViewBroomPointSaveInfo,
  TableViewConnectionPointSaveInfo,
  EditorBreakpoint,
  TextMacro,
  TableRow,
  NxAppLayout,
  NxAppProperties,
  LineageInfo,
  NxGetObjectOptions,
  NxGetBookmarkOptions,
  NxRange,
  NxMatchingFieldInfo,
  AssociationScore,
  FieldScores,
  ContentLibraryList,
  ContentLibraryListItem,
  StaticContentList,
  StaticContentListItem,
  DoReloadExResult,
  DoReloadExParams,
  ScriptSyntaxError,
  Connection,
  DatabaseInfo,
  Database,
  DatabaseOwner,
  DataTable,
  DataField,
  DataRecord,
  FilterInfo,
  FolderItem,
  FileDataFormat,
  DelimiterInfo,
  DataTableEx,
  SearchCombinationOptions,
  SearchSuggestionResult,
  SearchSuggestItem,
  SearchPage,
  SearchGroupOptions,
  SearchGroupItemOptions,
  SearchAssociationResult,
  SearchFieldDictionary,
  SearchTermResult,
  SearchCharRange,
  SearchMatchCombination,
  SearchFieldMatch,
  SearchResult,
  SearchGroup,
  SearchGroupItem,
  SearchGroupItemMatch,
  SearchAttribute,
  SearchObjectOptions,
  AppScript,
  ProgressData,
  ErrorData,
  ProgressMessage,
  DocListEntry,
  InteractDef,
  AppEntry,
  BNFDef,
  ScriptFunction,
  OdbcDsn,
  OleDbProvider,
  DriveInfo,
  CodePage,
  CustomConnector,
  NxStreamListEntry,
  NxEngineVersion
])
final Serializers serializers = _$serializers;
